<?php
/**
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 *
 * @package    Vpc_Rqa
 * @subpackage Vpc_Rqa/includes
 */

/**
 * Description of class-mb-confog
 *
 * @author HL
 */
class VPC_Rqa_Form_Data {

	/**
	 * The ID
	 *
	 * @var string
	 */
	public $id;

	/**
	 * The settings
	 *
	 * @var array
	 */
	public $settings;

	/**
	 * Function to initialize the class and set its properties.
	 *
	 * @method __construct
	 */
	public function __construct() {

	}

	/**
	 * Register the config custom post type
	 */
	public function register_cpt_form_datas() {

		$labels = array(
			'name'               => _x( 'Quote Requests', 'vpc-rqa' ),
			'singular_name'      => _x( 'Quote Requests', 'vpc-rqa' ),
			'add_new'            => _x( 'New quote request', 'vpc-rqa' ),
			'add_new_item'       => _x( 'New quote request', 'vpc-rqa' ),
			'edit_item'          => _x( 'Edit Quote Request', 'vpc-rqa' ),
			'new_item'           => _x( 'New quote request', 'vpc-rqa' ),
			'view_item'          => _x( 'View quote request', 'vpc-rqa' ),
			'not_found'          => _x( 'No quote request found', 'vpc-rqa' ),
			'not_found_in_trash' => _x( 'No quote request in the trash', 'vpc-rqa' ),
			'menu_name'          => _x( 'Quote requests', 'vpc-rqa' ),
			'all_items'          => _x( 'Quote requests', 'vpc-rqa' ),
		);

		$args = array(
			'labels'              => $labels,
			'hierarchical'        => false,
			'description'         => 'Quote requests',
			'supports'            => array( 'title' ),
			'public'              => false,
			'show_ui'             => true,
			'show_in_menu'        => 'edit.php?post_type=vpc-config',
			'show_in_nav_menus'   => false,
			'publicly_queryable'  => false,
			'exclude_from_search' => true,
			'has_archive'         => false,
			'query_var'           => false,
			'can_export'          => true,
			'menu_icon'           => 'dashicons-feedback',
		);

		register_post_type( 'vpc-rqa-form-data', $args );
	}

	/**
	 * Function to hide the 'New quote request' button.
	 */
	public function disable_new_posts() {
		// Hide sidebar link.
		global $submenu;
		unset( $submenu['edit.php?post_type=vpc-rqa-form-data'][10] );
		// Hide link on listing page.
		if ( ( isset( $_GET['post_type'] ) && ! wp_verify_nonce( sanitize_text_field( wp_unslash( $_GET['post_type'] ) ) ) && 'vpc-rqa-form-data' === sanitize_text_field( wp_unslash( $_GET['post_type'] ) ) ) ||
		( isset( $_GET['post'] ) && ! wp_verify_nonce( sanitize_text_field( wp_unslash( $_GET['post'] ) ) ) && 'vpc-rqa-form-data' === get_post_type( sanitize_text_field( wp_unslash( $_GET['post'] ) ) ) ) ) {
			echo '<style type="text/css">
				a.page-title-action { display:none; }
				</style>';
		}
	}

	/**
	 * Adds the metabox for the config CPT
	 */
	public function get_form_datas_metabox() {

		$screens = array( 'vpc-rqa-form-data' );

		foreach ( $screens as $screen ) {
			add_meta_box(
				'vpc-rqa-user-data-box',
				__( 'User Data', 'vpc' ),
				array( $this, 'get_user_datas' ),
				$screen
			);
			add_meta_box(
				'vpc-rqa-user-config_data_box',
				__( 'User Configuration Data', 'vpc' ),
				array( $this, 'get_user_config_datas' ),
				$screen
			);
		}
	}

	/**
	 * Function to get the user datas.
	 */
	public function get_user_datas() {
		$post_id    = get_the_ID();
		$post_metas = get_post_meta( $post_id, 'user_datas', true );

		if ( is_array( $post_metas ) ) {
			?>
		<div class="o-metabox-container">
			<table class='form_datas_box'>
			<thead>
			<th><?php esc_html_e( 'Fields', 'vpc_rqa' ); ?></th><th><?php esc_html_e( 'Values', 'vpc_rqa' ); ?></th>
			</thead>
			<tbody>
			<?php
			foreach ( $post_metas as $name => $value ) {
				echo '<tr><td>' . esc_html( ucfirst( $name ) ) . '</td><td><input type="text" value="' . esc_html( $value ) . '" style="width: 100% !important;"></td></tr>';
			}
			?>
			</tbody>
			</table>
		</div>
			<?php
		}
	}

	/**
	 * Function to get the user configuration's datas.
	 */
	public function get_user_config_datas() {
		$post_id    = get_the_ID();
		$post_metas = get_post_meta( $post_id, 'user_config_data', true );
		$product_id = get_post_meta( $post_id, 'product_id', true );
		$quantity   = get_post_meta( $post_id, 'quantity', true );
		$config     = get_product_config( $product_id );
		$text_html  = '';

		$allowed_tags = vpc_rqa_get_allowed_tags();
		if ( is_array( $post_metas ) ) {
			?>
			<div class="o-metabox-container">
				<table class='form_datas_box'>
				<thead>
				<th><?php esc_html_e( 'Components', 'vpc_rqa' ); ?></th><th><?php esc_html_e( 'Options', 'vpc_rqa' ); ?></th>
				</thead>
				<tbody>
				<?php
				foreach ( $post_metas as $name => $value ) {
					if ( 'recap' === $name ) {
						if ( is_array( $value ) ) {
							foreach ( $value as $component => $option ) {
								if ( is_array( $option ) ) {
									$options = '';
									foreach ( $option as $index => $opt ) {
										$options .= $opt . ', ';
									}
									echo '<tr><td>' . esc_html( ucfirst( $component ) ) . '</td><td><input type="text" value="' . esc_html( $options ) . '" style="width: 100% !important;"></td></tr>';
								} else {
									echo '<tr><td>' . esc_html( ucfirst( $component ) ) . ' : </td><td>' . wp_kses( $option, $allowed_tags ) . '</td></tr>';
								}
							}
						}
					}
					if ( 'preview' === $name ) {
						if ( is_array( $value ) ) {
							if ( 'true' === $post_metas['multiview'] ) {
								foreach ( $value as $key => $url ) {
									$text_html .= "<div style='font-weight:bold;font-size:17px;text-transform:uppercase;text-align:center;padding: 20px;'> View " . $key . "</div><img style='width:50%;' src='" . $url . "' /><br>";
								}
							} else {
								$text_html .= "<div style='font-weight:bold;font-size:17px;text-transform:uppercase;text-align:center;padding: 20px;'>Preview</div><div style='text-align: center;'><img style='width:50%' src='" . $value[0] . "' /></div><br>";
							}
						}
					}
				}
				echo '<tr><td>' . esc_html( 'Quanity' ) . ' : </td><td>' . esc_html( $quantity ) . '</td></tr>';

				?>
				</tbody>
				</table>
			<?php echo wp_kses_post( $text_html ); ?>
			</div>
			<?php
		}
	}

}
