(function ($) {
    'use strict';
    $(document).ready(function () {
	if (typeof vpc != 'undefined') {
	    if (typeof $('#raq-modal') !== 'undefined' && $('#raq-modal').length !== 0) {
		$('body').append($('#raq-modal'));
	    }



	    $(document).on('click', '#vpc-request-quote', function () {
		var form_data = {};
		if (vpc.isOfb === true) {
		    var form_is_valid = $('form.formbuilt').validationEngine('validate', {showArrow: false});
		    if (form_is_valid) {
			if ($('#rqa_form .omodal-body').hasClass('success')) {
			    $('#rqa_form').remove();
			    $('#raq-modal .omodal-content').append(vpc.form);
			    $('#raq-modal').omodal('show');
			} else {
			    $('#raq-modal').omodal('show');
			}
		    }
		} else {
		    if ($('#rqa_form .omodal-body').hasClass('success')) {
			$('#rqa_form').remove();
			$('#raq-modal .omodal-content').append(vpc.form);
			$('#raq-modal').omodal('show');
		    } else {
			$('#raq-modal').omodal('show');
		    }
		}
	    });

	    $(document).on('click', '.vpc-mo-button', function () {
		$("#rqa_form").validationEngine('attach', {
		    showOneMessage: true,
		    scroll: false,
		    promptPosition: "topCenter",
		    focusFirstField: false,
		    updatePromptsPosition: true,
		    onValidationComplete: function (form, status) {
			if ($('#CaptachaResult').data('id') != $('#captcha').val()) {
			    $('#raq-modal .omodal-body').animate({
				scrollTop: $('#captcha').offset().top
			    }, "slow");
			    $('#captcha').addClass('rqa_error');
			    return false;
			}
			$('#captcha').removeClass('rqa_error');
			var custom_vars = {};
			status = wp.hooks.applyFilters('vpc.message_sent_process', status, form);
			var decoded_active_views = "";
			if (status) {
			    nb_images = 0;
			    $('#rqa_form .vpc-mo-button').addClass('disabledClick');
			    var prod_id = $('#vpc-request-quote').attr('data-prod-id');
			    var recap = $('#vpc-container').find(':input').serializeJSON();
			    if (vpc.views)
				decoded_active_views = JSON.parse(active_views);
			    if (vpc.views) {
				var multiview = true;
				var imgs = get_finish_image_by_view(vpc.vpc_selected_items_selector);
			    } else {
				var multiview = false;
				var imgs = get_finish_image(vpc.vpc_selected_items_selector);
			    }
			    merge_all_images_of_preview(imgs).then(function (status) {
				if (status === 'completed') {
				    setTimeout(function () {
					if (typeof window.__canvases !== 'undefined' && window.__canvases.length !== 0) {
					    add_custom_texts_and_uploads_datas_on_canvas();
					}
					custom_vars['preview_imgs_merged'] = JSON.stringify(generate_canvas_images());

					var data_object = {
					    action: "save_vpc_rqa_canvas_img",
					    multiview: multiview,
					    recap: recap,
					    custom_vars: custom_vars,
					    imgs_by_views: imgs,
					    rqa_canvas_img_nonce: "rqa_canvas_img_nonce"

					};
					$.ajax({
					    type: 'POST',
					    url: ajax_object.ajax_url,
					    data: data_object,
					    success: function (result) {
						nb_images = 0;
						vpc_rqa_save_data(result, prod_id, form, multiview, decoded_active_views);
					    }
					});
				    }, 200 * nb_images);
				}
			    });
			} else
			    wp.hooks.doAction('vpc.message_sent_process');
		    }

		});
	    });

	    wp.hooks.addAction('vpc.default_preview_builder_process','vpc-rqa', function (items_selected) {
		nb_images = 0;
		if (typeof active_views != "undefined")
		    get_finish_image_by_view(items_selected);
		else
		    get_finish_image(items_selected);
	    });

	}

	/**
	 * Function to get previews.
	 *
	 * @param  {[string]} result    Completed level state.
	 * @param  {[string]} prod_id   Product ID.
	 * @param  {[string]} form      A form's data.
	 * @param  {[string]} multiview Multiview state value.
	 */
	function vpc_rqa_save_data(result, prod_id, form, multiview, decoded_active_views) {
	    var form_data = $(form).serializeJSON();
	    var recap = $('#vpc-container').find(':input').serializeJSON();
		var quantity = $("#vpc-qty").val();
	    var canvas_data = {};
	    if (typeof window.__canvases !== 'undefined' && window.__canvases.length !== 0) {
		var canvases = window.__canvases;
		canvas_data = get_canvas_data(canvases);
		recap['canvas_data'] = JSON.stringify(canvas_data);
	    }
	    $.post(
		    ajax_object.ajax_url,
		    {
			action: 'save_form_datas',
			frm_data: form_data,
			recap: recap,
			prod_id: prod_id,
			preview_saved: result,
			multiview: multiview,
			views: decoded_active_views,
			quantity: quantity,
			rqa_form_datas_nonce: "rqa_form_datas_nonce"

		    },
		    function (data) {
			$('#rqa_form .vpc-mo-button').removeClass('disabledClick');
			$('#rqa_form .omodal-body').addClass('success');
			// $('.rqa_wpc_header').html(vpc.rqa_modal_title);
			$('#rqa_form .success').html('<i class="fa fa-check"></i>' + vpc.email_sent);
		    });
	}
    });

})(jQuery);
