<?php
/**
 * The plugin bootstrap file
 *
 * This file is read by WordPress to generate the plugin information in the plugin
 * admin area. This file also includes all of the dependencies used by the plugin,
 * registers the activation and deactivation functions, and defines a function
 * that starts the plugin.
 *
 * @link              https://www.orionorigin.com/product/request-a-quote-add-on/?utm_source=Installed+pro+plugin&utm_medium=Source+code&utm_campaign=VPC-RQA
 * @since             1.0.0
 * @package           Vpc_Rqa
 *
 * @wordpress-plugin
 * Plugin Name:       Visual Products Configurator Request a Quote Addon
 * Plugin URI:        https://www.orionorigin.com/product/request-a-quote-add-on/?utm_source=Installed+pro+plugin&utm_medium=Source+code&utm_campaign=VPC-RQA
 * Description:       Allow to send request a quote.
 * Version:           3.1.1
 * Author:            orion
 * Author URI:        https://www.orionorigin.com/?utm_source=Installed+pro+plugin&utm_medium=Author+URI&utm_campaign=VPC-RQA
 * License:           GPL-2.0+
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain:       vpc-rqa
 * Domain Path:       /languages
 */

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}

define( 'VPC_RQA_URL', plugins_url( '/', __FILE__ ) );
define( 'VPC_RQA_DIR', dirname( __FILE__ ) );
define( 'VPC_RQA_MAIN_FILE', 'visual-product-configurator-request-a-quote-addon/vpc-rqa.php' );
define( 'VPC_RQA_VERSION', '3.1.1' );
define( 'VPC_RQA_NAME', 'Visual Product Configurator Request a Quote Add-on' );

/**
 * The code that runs during plugin activation.
 * This action is documented in includes/class-vpc-rqa-activator.php
 */
function activate_vpc_rqa() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-vpc-rqa-activator.php';
	Vpc_Rqa_Activator::activate();
}

/**
 * The code that runs during plugin deactivation.
 * This action is documented in includes/class-vpc-rqa-deactivator.php
 */
function deactivate_vpc_rqa() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-vpc-rqa-deactivator.php';
	Vpc_Rqa_Deactivator::deactivate();
}

register_activation_hook( __FILE__, 'activate_vpc_rqa' );
register_deactivation_hook( __FILE__, 'deactivate_vpc_rqa' );

/**
 * The core plugin class that is used to define internationalization,
 * admin-specific hooks, and public-facing site hooks.
 */
require plugin_dir_path( __FILE__ ) . 'includes/class-vpc-rqa.php';
require plugin_dir_path( __FILE__ ) . 'includes/class-vpc-rqa-form-data.php';
require plugin_dir_path( __FILE__ ) . 'includes/functions.php';

/**
 * Begins execution of the plugin.
 *
 * Since everything within the plugin is registered via hooks,
 * then kicking off the plugin from this point in the file does
 * not affect the page life cycle.
 *
 * @since    1.0.0
 */
function run_vpc_rqa() {

	$plugin = new Vpc_Rqa();
	$plugin->run();
}

run_vpc_rqa();
